# Combine data using least squares method

import os
import numpy as np
import pickle
import torch
import torch.nn as nn
from sklearn.preprocessing import MinMaxScaler

data_path = '../data/aps/9years'
dim = 50
class Data_integration(object):
    def __init__(self, params):
        # count starts from 2
        self.encoding_map_path = os.path.join(data_path+"/4_encoding_map", "encoding_map" + str(1) + ".pkl")
        self.path_doc_topic = os.path.join("../data/output", params["dataset"], "doc_topic", params["TopicModel"]["path_doc_topic"] + str(1) + ".txt")
        self.path_doc_topic2 = os.path.join("../data/output", params["dataset"], "doc_topic", params["TopicModel"]["path_doc_topic"] + str(params["count"]) + ".txt")
        self.encoding_map_path2 = os.path.join(data_path+"/4_encoding_map", "encoding_map" + str(params["count"]) + ".pkl")
        self.reflect_data_path2 = os.path.join("../data/output", params["dataset"], "integration", "reflect_data"+str(params["count"]) + ".npy")
        self.reflect_data_map_path = os.path.join("../data/output", params["dataset"], "integration", "reflect_data_map" + str(1) + ".pkl")
        self.reflect_data_map_path2 = os.path.join("../data/output", params["dataset"], "integration", "reflect_data_map" + str(params["count"]) + ".pkl")
        # self.reflect_tatal_data_path = os.path.join("../data/output", params["dataset"], "integration", "reflect_total_data"+ ".npy")
        self.sharedata = 21914 #21914(aps-9years) #19738(aps-7years) #17355(aps-5years)  # 61464(weibo-1h) # the nodes of shared datas
        self.paramscount = params["count"]
        self.idmap_path = '../src/idmap.pkl'
        self.final_map2 = '../src/vector_map_all2.pkl'
        self.encoding_map_new_path= os.path.join(data_path+"/4_encoding_map",
                                                   "encoding_map_new" + str(1) + ".pkl")
        self.encoding_map_new_path2 = os.path.join(data_path+"/4_encoding_map", "encoding_map_new" + str(params["count"]) + ".pkl")

    def numpy_array(self): # This step can also be optimized like reflectdata_map()
        # Convert file one into a dictionary in array form
        vectors_map1 = {}  # Place outside the loop

        #Read pkl data
        with open(self.encoding_map_path, 'rb') as r_file:
            data_map = pickle.load(r_file, encoding='bytes')

        # Swap dictionary key-value pairs
        data_map2 = dict(zip(data_map.values(), data_map.keys()))
        with open(self.encoding_map_new_path, 'wb') as w_file:
            pickle.dump(data_map2, w_file)

        line = 0  #Start from line 0 of the doc_topic1 file
        with open(self.path_doc_topic, 'r') as r_file:
            for row in r_file:
                list1 = []
                row1 = row.split(" ")
                for i in row1:
                    i = float(i)
                    list1.append(i)
                vectors_map1[data_map2[line]] = list1

                # for i in data_map.keys():  # Take out the keys in the dictionary one by one
                #     if data_map[i] == line:  # If the initial data recoded value is the same as the row of doc_topic
                #         vectors_map1[i] = list1  # Just assign the value
                line = line + 1

        # Save the dictionary in array form of doc_topic1
        with open(self.reflect_data_map_path,'wb') as fo:
            pickle.dump(vectors_map1, fo)  # The values ​​stored in the small dictionary are float type
        print("The vector matrix dictionary of doc_topic1 has been completed!")
        return vectors_map1

    #Multilayer perceptron
    def multilayerP(self):
        # Confirm Y
        Y = np.zeros((self.sharedata,dim), dtype = float)
        with open(self.path_doc_topic,"r") as r_file:
            # 61464 row vector
            count = 0
            for line in r_file:
                if count < self.sharedata:
                    linelist = []
                    vector = line.split(" ")
                    for i in vector:
                        i = float(i)
                        linelist.append(i)
                    Y[count,:] = linelist
                    count = count + 1
        Y = torch.from_numpy(Y).float()
        # print("Y:",Y)

        X = np.zeros((self.sharedata, dim), dtype = float)
        with open(self.path_doc_topic2, "r") as r_file:
            # 61464 row vector
            count = 0
            for line in r_file:
                if count < self.sharedata:
                    linelist = []
                    vector = line.split(" ")
                    for i in vector:
                        i = float(i)
                        linelist.append(i)
                    X[count, :] = linelist
                    count = count + 1
        X = torch.from_numpy(X).float()
        # print("X:",X)

        # Get the data to be predicted
        with open(self.path_doc_topic2, "r") as r_file:
            totallines = len(r_file.readlines())  # Get the line number of the file
        with open(self.path_doc_topic2, "r") as r_file:
            test_data = np.zeros((totallines - self.sharedata, dim), dtype=float)
            num = 0
            count = 0
            for line in r_file:
                num = num + 1 #Move the number of lines to the specified position
                if num > self.sharedata - 1:
                    # print("num:", num)
                    if count < totallines - self.sharedata:
                        linelist = []
                        vector = line.split(" ")
                        for i in vector:
                            i = float(i)
                            linelist.append(i)
                        # print("linelist:",linelist)
                        test_data[count, :] = linelist
                        count = count + 1
        test_data = torch.from_numpy(test_data).float()

        #neural_network
        d = dim
        step_size = 0.05
        n_epochs = 50
        n_hidden = 256
        momentum = 0.9
        d_out = dim
        neural_network = nn.Sequential(
            nn.Linear(d,n_hidden),
            nn.Sigmoid(),
            nn.Linear(n_hidden,d_out),
            nn.ReLU()
        )
        loss_func = nn.MSELoss()
        optim = torch.optim.SGD(neural_network.parameters(), lr=step_size, momentum=momentum)
        print('iter, \tloss')
        for i in range(n_epochs):
            y_hat = neural_network(X)
            loss = loss_func(y_hat, Y)
            optim.zero_grad()
            loss.backward()
            optim.step()

            if i % (n_epochs // 10 ) == 0:
                print('{}, \t{:.2f}'.format(i, loss.item()))

        # print("y_hat:", y_hat)

        # Predict data
        print("test_data:",test_data)
        predict_data = neural_network(test_data)
        print("predict_data.shape:",predict_data.shape,"\n")
        print("predict_data:",predict_data)

        # Convert to numpy and store
        predict_data = predict_data.detach().numpy()
        np.save(self.reflect_data_path2, predict_data)

    # Obtain the weight matrix and calculate the mapping matrix
    def leastsqure(self):

        # Confirm Y
        Y = np.zeros((self.sharedata,dim), dtype = float)
        with open(self.path_doc_topic,"r") as r_file:
            # 61464 row vector
            count = 0
            for line in r_file:
                if count < self.sharedata:
                    linelist = []
                    vector = line.split(" ")
                    for i in vector:
                        i = float(i)
                        linelist.append(i)
                    Y[count,:] = linelist
                    count = count + 1
        # print("Y:",Y)

        X = np.zeros((self.sharedata, dim), dtype = float)
        with open(self.path_doc_topic2, "r") as r_file:
            # 61464 row vector
            count = 0
            for line in r_file:
                if count < self.sharedata:
                    linelist = []
                    vector = line.split(" ")
                    for i in vector:
                        i = float(i)
                        linelist.append(i)
                    X[count, :] = linelist
                    count = count + 1
        # print("X", X)
        theta0 = np.ones(self.sharedata)
        X = np.c_[theta0,X] #Add to first column
        # print("Add the input matrix X of b:",X)

        # optimization
        # X2 = X.T
        # X3 = np.dot(X2, X)
        # X4 = np.linalg.inv(X3)
        # W = np.dot(np.dot(X4,X2),Y)

        W = np.asarray(np.linalg.lstsq(X,Y, rcond=None)[0])
        print("The obtained weight matrix is:", '\n', W)
        # print('the shape of W:',W.shape)

        # print("X_predict:", np.dot(X,W))
        # print("the shape of predict:",np.dot(X,W).shape)

        # Get the matrix to be mapped
        with open(self.path_doc_topic2, "r") as r_file:
            totallines = len(r_file.readlines())  # Get the line number of the file
        with open(self.path_doc_topic2, "r") as r_file:
            A2 = np.zeros((totallines - self.sharedata, dim), dtype=float)
            num = 0
            count = 0
            for line in r_file:
                num = num + 1 #Move the number of lines to the specified position
                if num > self.sharedata - 1:
                    # print("num:", num)
                    if count < totallines - self.sharedata:
                        linelist = []
                        vector = line.split(" ")
                        for i in vector:
                            i = float(i)
                            linelist.append(i)
                        # print("linelist:",linelist)
                        A2[count, :] = linelist
                        count = count + 1
        # print("The matrix output before conversion is:", '\n', A2)
        #Add one more column b
        theta0_1 = np.ones(len(A2))
        A2 = np.c_[theta0_1,A2]

        A2_1 = np.dot(A2, W)  #Map to the matrix in the topic of file one
        print("The converted matrix output is:", '\n', A2_1)
        np.save(self.reflect_data_path2, A2_1)
        # print("params:", self.paramscount)
        print("Finished reflect data!")

    # Get the dictionary of other mapped matrices - it takes a long time
    def reflectdata_map(self):
        #Load the matrix vector obtained in the previous step
        reflect_data = np.load(self.reflect_data_path2)

        vectors_map = {}
        # Based on the recoded dictionary
        with open(self.encoding_map_path2, 'rb') as r_file:
            data_map = pickle.load(r_file, encoding="bytes")

        # Swap dictionary key-value pairs
        data_map2 = dict(zip(data_map.values(), data_map.keys()))
        with open(self.encoding_map_new_path2, 'wb') as w_file:
            pickle.dump(data_map2, w_file)

        for row in range(0, reflect_data.shape[0]):
            vectors_map[data_map2[row+self.sharedata]] = reflect_data[row, :]
            # The above line of code optimizes the following code
            # for i in data_map.keys():
            #     if data_map[i] == row + self.sharedata:  # If the initial data recoded value is the same as the row of doc_topic
            #         vectors_map[i] = reflect_data[row, :]  # Just assign the value

        # print("the length of each vector_map:",len(vectors_map))
        with open(self.reflect_data_map_path2, 'wb') as fo:  # 'w' indicates write-only form, which will be cleared every time it is run.
            pickle.dump(vectors_map, fo)  # The values ​​stored in the small dictionary are float type
        print("Finished reflect data map!")

    # Merge dictionaries of all files
    def integration_map(self, vector_map_all):
        with open(self.reflect_data_map_path2,"rb") as r_file:
            vector_map = pickle.load(r_file, encoding='bytes')

        print("the length of each vector_map:",len(vector_map))
        print("Length of vector_map_all before update:",len(vector_map_all))
        vector_map_all.update(vector_map)
        print("The updated length of vector_map_all:",len(vector_map_all))
        return vector_map_all

    # According to the idmap.pkl file, convert the large dictionary into a large array
    def map_to_numpy(self,final_map):
        # #Convert to the format required by hawkes
        with open(final_map, 'rb') as r_file:
            vectors_map = pickle.load(r_file, encoding="bytes")
        print("the length of vector_map:",len(vectors_map))

        # # to save to Dictionary with keys reversed
        # vectors_map2 = dict(zip(vectors_map.values(), vectors_map.keys()))
        # with open(self.final_map2,'wb') as w_file:
        #     pickle.dump(vectors_map2, w_file)

        with open(self.idmap_path, 'rb') as r_file:
            idmaplist = pickle.load(r_file, encoding='bytes')
        print("the length of idmap:",len(idmaplist))

        vector_array = np.zeros((len(idmaplist), dim), dtype=float)
        # Create a large numpy array to store
Normalized vector_array:
        count = 0
        for key in vectors_map.keys():
            if int(key) in idmaplist:  # Because the number of keys in the large dictionary and the number of idmap values ​​do not all correspond one to one.
                i = idmaplist.index(int(key))  # Get the index value of the list
                vector_array[i, :] = vectors_map[key]  # Assign a value to the array
                count = count + 1
            if count % 10000 == 0:
                print(count)
        print("vector_array:",vector_array)
        np.save('vector_array', vector_array)

    def standard_numpy(self):
        vector_array = np.load('vector_array.npy')
        data = MinMaxScaler()
        mm_vector_array = data.fit_transform(vector_array)
        print("Normalized vector_array:",mm_vector_array)
        np.save('vector_array_standard',mm_vector_array)

