import os
import numpy as np
import pickle

# data_path='../data/weibo/1h'
data_path = '../data/aps/9years'

class Data_Preprocessing(object): #Pass in the file count
    def __init__(self, params):#self is the created instance itself, which contains various attributes of self
        self.txt_file_path = os.path.join(data_path+"/1_txt_file","initial_data"+str(params["count"])+".txt")
        self.split_txt_file_path = os.path.join(data_path+"/2_split_txt_file","split_data"+str(params["count"])+".txt")
        self.encoding_txt_file_path = os.path.join("../data/input", params["dataset"], "encoding_data"+str(params["count"])+".txt")
        self.encoding_map_path = os.path.join(data_path+"/4_encoding_map","encoding_map"+str(params["count"])+".pkl")
        self.cascade_vector_map_path = os.path.join(data_path+"/5_cascade_vector_map","cascade_vectors_map"+str(params["count"])+".pkl")
        self.path_doc_topic = os.path.join("../data/output", params["dataset"],"doc_topic",
                                           params["TopicModel"]["path_doc_topic"] + str(params["count"]) + ".txt")
        self.count = params["count"]
    def split_txt_file(self):
        #Initial data; partial data from three files has been extracted
        if os.path.exists(self.txt_file_path) is False:
            print("fail")
            return

        with open(self.txt_file_path, 'r') as r_file:
            for row in r_file:
                lists = row.split("\t")
                edge_information = lists[4].split(" ")
                for row_1 in edge_information:
                    edge_information_1 = row_1.split(":")
                    edge_information_1 = np.delete(edge_information_1, 2)

                    with open(self.split_txt_file_path, 'a') as w_file:  # Write the split data to the file
                        w_file.write(' '.join(edge_information_1))
                        w_file.write('\n')
        print("The first step: split initial data successfully!")  #The number of output rows is 155087 (3200 data) rows and 232854 (4100 data) rows

    def new_encoding(self):
        dict_data = {}
        value = 0
        with open(self.split_txt_file_path, 'r') as r_file:
            for edges in r_file:
                edge = edges.split()
                for i in edge:
                    if i not in dict_data.keys():
                        dict_data[i] = value
                        value += 1
                # Split the data and write it into the document
                with open(self.encoding_txt_file_path, 'a') as e_file:
                    for each in edge:
                        e_file.write(str(dict_data[each]))
                        e_file.write(' ')
                    e_file.write('\n')
            with open(self.encoding_map_path, 'wb+') as fo:  #Write data to pkl file as dictionary
                pickle.dump(dict_data, fo)
        # self.temporary()
        print("The second step: encoding data successfully!")

    def temporary(self):
        j = 0
        with open(self.split_txt_file_path, 'r') as r_file:
            for row in r_file:
                lists = row.split()
                for i in lists:
                    if j < int(i):
                        j = int(i)
        print("split file"+str(self.count)+"maximum value before encoding:", j)

        j = 0
        with open(self.encoding_txt_file_path, 'r') as r_file:
            for row in r_file:
                lists = row.split()
                for i in lists:
                    if j < int(i):
                        j = int(i)
        print("encoding file"+str(self.count)+"maximum value after encoding:", j)


    # Convert doc_topic.txt into dictionary format (original data: vector)
    def node_vectors(self):
        vectors_map = {}  # Place outside the loop

        #Read pkl data
        with open(self.encoding_map_path, 'rb') as r_file:
            data_map = pickle.load(r_file, encoding='bytes')

        line = 0  #Start from line 0 of the doc_topic file
        with open(self.path_doc_topic, 'r') as r_file:
            for row in r_file:
                for i in data_map.keys():  # Take out the keys in the dictionary one by one
                    if data_map[i] == line:  # If the initial data recoded value is the same as the row of doc_topic
                        vectors_map[i] = row  # Just assign the value
                line = line + 1
        # print(vectors_map)

        with open(self.cascade_vector_map_path, 'ab') as fo:
            pickle.dump(vectors_map, fo)  # The values ​​stored in the large dictionary are character type and need to be changed to float type when assigning values later.

        print("The third step: total_cascade_vectors_map.pkl successfully finished!")
