#!/usr/bin/env python
# -*- coding: utf-8 -*-

import re
import json
from data_preprocessing import Data_Preprocessing
from preprocess import PreProcess
from topic_model import GraphAnchorLDA
from data_integration import Data_integration
import pickle
import os


def load_json_file(file_path):
    with open(file_path, "r") as f:
        s = f.read()
        s = re.sub('\s', "", s)  # Regular match\s space,tab key,replace with none

    params = json.loads(s)  #Convert string to python object

    print("dataset:", params["dataset"])
    return params

final_map = '..\src\\vector_map_all.pkl'

if __name__ == "__main__":
    params = load_json_file("../config.json")
    # print(params)  # Check the output format of params
    initialcount = params["count"]
    # dataintegration = Data_integration(params)

    # This block does not need to be run
    # with open(os.path.join("../data/output", params["dataset"], "integration", "reflect_data_map" + str(1) + ".pkl"), "rb") as r_file:
    #         vector_map_all = pickle.load(r_file, encoding='bytes')

    while params["count"] < params["filecounts"]+1:  # Loop through all files

        # # The first step: split the data and input them into graphstone for processing.
        # datapreprocess = Data_Preprocessing(params)
        # datapreprocess.split_txt_file()  # Split data
        # datapreprocess.new_encoding()  # Re-encoding - Each time you run it again, you need to delete the original encoding_data.

        # # GraphStone part
        # preprocesser = PreProcess(params)
        # preprocesser.generate_topic_concepts()
        #
        # graph_topic_model = GraphAnchorLDA(params)
        # graph_topic_model.learn_topic_distribution()  # This step calculates the word_topic data we need
        # graph_topic_model.calculate_node_topic_distribution()  # This step calculates the doc_topic structure vector

        # Obtain the dictionary (vector corresponding to the original data) - this step is part of the first step
        # datapreprocess.node_vectors()
        # print("\n Very Good! You successfully finished node_vectors.")

        # Step 2: Combine data using least squares method/MLP
        dataintegration = Data_integration(params)
        if params["count"] == 1:
            vector_map_all = dataintegration.numpy_array()
        else:
            # Obtain the weight matrix and map the data
            dataintegration.leastsqure()
            # dataintegration.multilayerP()

            # # Get the dictionary of mapping data
            dataintegration.reflectdata_map()
            #
            # # In the second step, convert doc_topic0 into a dictionary in array form
            vector_map_all = dataintegration.integration_map(vector_map_all)

            if params["count"] == params["filecounts"]:
                # Save a large dictionary
                with open(final_map, 'wb') as fo:
                    pickle.dump(vector_map_all, fo)  # The values stored in the large dictionary are float type
                #The next step is to combine idmap and convert it into the array form we need.
                dataintegration.map_to_numpy(final_map)
                dataintegration.standard_numpy()  # Normalize the value range of the array to between -1-1

        params["count"] = params["count"] + 1
        print("Current number of files in main function:", params["count"] - 1)
        # print("vector_map_all in main:",len(vector_map_all))








